Subject: [Lsr] WGLC request for draft-ietf-lsr-ospfv3-extended-lsa-yang

From: Yingzhen Qu <[email-masked]>
Date: Fri, 7 Aug 2020 21:55:19 +0000

Hi Chairs,

On behalf of the authors, I’d like to request WG LC of “YANG Model for OSPFv3 Extended LSAs”: https://datatracker.ietf.org/doc/draft-ietf-lsr-ospfv3-extended-lsa-yang/

This model severs as a foundation for future OSPFv3 extensions using extended LSAs (RFC 8362) and will be augmented by those new features, such as OSPFv3 Extensions for Segment Routing.

Please let us know if you need any other info.

Thanks,
Yingzhen

---

From: tom petch <[email-masked]>
Date: Mon, 10 Aug 2020 11:00:55 +0000

From: Lsr <[email-masked]> on behalf of Yingzhen Qu <[email-masked]>
Sent: 07 August 2020 22:55

Hi Chairs,

<tp>
This is a tough read.  I would like to compare the data structures with those in the RFC defining the LSA but the YANG module is devoid of such references. Adding those references would encourage me to review more.

And there are a number of admin issues.

Requirements lacks RFC8174 in the body of the I-D

I see no upper case words in the YANG module but you include the boilerplate.

Tree diagrams no reference

XXXX means different I-D in different places

import lack references

security lacks TLS1.3

RFC8242 not in I-D References

RFC8174 not in I-D References

import OSPF must be Normative

Tom Petch

Thanks,
Yingzhen

---

From: tom petch <[email-masked]>
Date: Wed, 12 Aug 2020 11:51:59 +0000

Looking at some more technical aspects of this

    /* Configuration */
        "This augments the OSPFv3 protocol configuration
         with segment routing.";
really?

      leaf extended-lsa-support {
      leaf extended-lsa-support {
why two? what does it mean if one is true and one false?  (why not more
than two?:-)

I wonder too where this boolean is best placed; there seems to me to be
no obvious ospfv3 place for it so
"/rt:routing/rt:control-plane-protocols/rt:control-plane-protocol/ospf:o
spf"
is probably as good as any.

       when "/rt:routing/rt:control-plane-protocols"
          + "/rt:control-plane-protocol/rt:type = 'ospf:ospfv3'"  {
is rt:type always set to ospfv3 as opposed to ospf? is there something
in ospf-yang that ensures this?

     * Link State Database (LSDB) Augmentations
      when "derived-from-or-self(/rt:routing/rt:control-plane-protocols"
         + "/rt:control-plane-protocol/rt:type,"
         + "'ospfv3')"  {
derived-from seems unnecessary for ospfv3, equality would do

    grouping ipv4-link-local-tlv {
      container ipv4-link-local-tlv {
        description "IPv6 Link-Local LSA TLV";
IPv6 looks odd here

    grouping ospfv3-e-lsa-area {
      description "Area scope OSPFv3 Extended LSAs.";
      container e-router {
        when  "derived-from(../../ospf:header/ospf:type,
'ospfv3-e-router-lsa')" {
I see nothing derived from 'ospfv3-e-router-lsa' so I cannot see when
this is true

            leaf type {
              type uint8;
this is an enumeration in ospf-yang

        when "derived-from(../../ospf:header/ospf:type,
'ospfv3-e-network-lsa')"
likewise I cannot see this being true

        when "derived-from(../../ospf:header/ospf:type,
'ospfv3-e-inter-area-prefix-lsa')"
and again

        when "derived-from(../../ospf:header/ospf:type,
'ospfv3-e-inter-area-router-lsa')"
and again

        when "derived-from-or-self(../../ospf:header/ospf:type,
'ospfv3-e-intra-area-prefix-lsa')"
I think you know this by now but this one would work but is not needed,
simple equality test would do.

        when "derived-from-or-self(../../ospf:header/ospf:type,
'ospfv3-e-as-external-lsa')"
again equality is all that seems to be needed

        when "derived-from-or-self(../../ospf:header/ospf:type,
'ospfv3-e-nssa-lsa')"
and again

        when "derived-from-or-self(../../ospf:header/ospf:type,
'ospfv3-e-link-lsa')
and again

Tom Petch

----- Original Message -----
From: <[email-masked]>
To: <[email-masked]>
Cc: <[email-masked]>
Sent: Friday, August 07, 2020 7:03 PM
Subject: I-D Action: draft-ietf-lsr-ospfv3-extended-lsa-yang-03.txt

> A New Internet-Draft is available from the on-line Internet-Drafts
directories.
> This draft is a work item of the Link State Routing WG of the IETF.
>
>         Title           : YANG Model for OSPFv3 Extended LSAs
>         Authors         : Acee Lindem
>                           Sharmila Palani
>                           Yingzhen Qu
>         Filename        :
draft-ietf-lsr-ospfv3-extended-lsa-yang-03.txt
>         Pages           : 26
>         Date            : 2020-08-07
>
> Abstract:
>    This document defines a YANG data model augmenting the IETF OSPF
YANG
>    model to provide support for OSPFv3 Link State Advertisement (LSA)
>    Extensibility as defined in RFC 8362.  OSPFv3 Extended LSAs provide
>    extensible TLV-based LSAs for the base LSA types defined in RFC
5340.
>
>
> The IETF datatracker status page for this draft is:
>
https://datatracker.ietf.org/doc/draft-ietf-lsr-ospfv3-extended-lsa-yang
/
>
> There are also htmlized versions available at:
> https://tools.ietf.org/html/draft-ietf-lsr-ospfv3-extended-lsa-yang-03
>
https://datatracker.ietf.org/doc/html/draft-ietf-lsr-ospfv3-extended-lsa
-yang-03
>
> A diff from the previous version is available at:
>
https://www.ietf.org/rfcdiff?url2=draft-ietf-lsr-ospfv3-extended-lsa-yan
g-03
>
>
> Please note that it may take a couple of minutes from the time of
submission
> until the htmlized version and diff are available at tools.ietf.org.
>
> Internet-Drafts are also available by anonymous FTP at:
> ftp://ftp.ietf.org/internet-drafts/
>
>
>

---

From: Yingzhen Qu <[email-masked]>
Date: Wed, 12 Aug 2020 21:36:32 +0000

Hi Tom,

Thank you for the review. Please see my answers inline.

I'll publish a new version of the draft soon addressing these comments, also comments from your previous email.

Thanks,
Yingzhen

On 8/12/20, 4:52 AM, "tom petch" <[email-masked]> wrote:

    
        /* Configuration */
 [YQ]: fixed. 
   
    [YQ]: The first configuration is at ospf process level, and the second is at area level. Please refer to RFC 8362 section 6.2.

[YQ]: I don't really understand your question here. In ietf-ospf.yang, type could be ospf, ospfv2 or ospfv3. This model is meant for OSPFv3 only.

[YQ]: yes, you're right.
    
        grouping ipv4-link-local-tlv {
          container ipv4-link-local-tlv {
            description "IPv6 Link-Local LSA TLV";
    IPv6 looks odd here
    [YQ]: thanks for catching this. (

[YQ]: this is meant for when lsa-header type is 'ospfv3-e-router-lsa', base identity is ospf-lsa-type defined in ietf-ospf.yang. I'm changing this to equality. Same for the followings.
    
                leaf type {
                  type uint8;
    this is an enumeration in ospf-yang
[YQ]: this is operational data, so I don't see this causing real problems. And it's possible that future OSPFv3 extensions may add more link types. 

    

    

    Tom Petch
    
    ----- Original Message -----
    From: <[email-masked]>
    To: <[email-masked]>
    Cc: <[email-masked]>
    Sent: Friday, August 07, 2020 7:03 PM
    Subject: I-D Action: draft-ietf-lsr-ospfv3-extended-lsa-yang-03.txt

    directories.
    YANG
    5340.
    > The IETF datatracker status page for this draft is:
    https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fdraft-ietf-lsr-ospfv3-extended-lsa-yang&amp;data=02%7C01%7Cyingzhen.qu%40futurewei.com%7C03231597e277451b29eb08d83eb6205a%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637328299234619301&amp;sdata=2%2BVcGUT2yBcSJWcaBTWd2sEyNTqyDsKPjhAGeYJbDDo%3D&amp;reserved=0
    /
    > https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-ietf-lsr-ospfv3-extended-lsa-yang-03&amp;data=02%7C01%7Cyingzhen.qu%40futurewei.com%7C03231597e277451b29eb08d83eb6205a%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637328299234629297&amp;sdata=EREBl54b02PTU74BURgfU%2F1hFCRCcka%2FRGrWU%2BZGGGg%3D&amp;reserved=0
    >
    https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fhtml%2Fdraft-ietf-lsr-ospfv3-extended-lsa&amp;data=02%7C01%7Cyingzhen.qu%40futurewei.com%7C03231597e277451b29eb08d83eb6205a%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637328299234629297&amp;sdata=WyUkgbPBkoOuOu2bK%2F%2BQCjzyqXizGNMwlkZVxXPvUx8%3D&amp;reserved=0
    -yang-03
    > A diff from the previous version is available at:
    https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Frfcdiff%3Furl2%3Ddraft-ietf-lsr-ospfv3-extended-lsa-yan&amp;data=02%7C01%7Cyingzhen.qu%40futurewei.com%7C03231597e277451b29eb08d83eb6205a%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637328299234629297&amp;sdata=S8yER1C8a3T5fzm9z5AXGIX0tvlu2zAXn35ThpcKbvU%3D&amp;reserved=0
    g-03
    submission
    > https://nam11.safelinks.protection.outlook.com/?url=ftp%3A%2F%2Fftp.ietf.org%2Finternet-drafts%2F&amp;data=02%7C01%7Cyingzhen.qu%40futurewei.com%7C03231597e277451b29eb08d83eb6205a%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637328299234629297&amp;sdata=zg4gKfMuMShFSUaqTDSeUtIXbAIL2vr6UGarQFKZGig%3D&amp;reserved=0
    >
    >
    >